/*----------------------------------------------------------------------------*/
/* Sat2Chart.exe Written by: Paul Higgins

Purpose: To start the Sat2Chart.REX Program
         Also if the the GKAP.Options.txt does not exist invoke the CHeck.rex 
         first then Sat2Chart.rex             
   
*/ 
/*----------------------------------------------------------------------------*/

/*  Executes the Check.REX and Sat2Chart.REX programs
 */

// #include "oorexxapi.h"    
// include <dos.h>
#include <stdio.h>
#include <stdlib.h> 
#include <iostream>

#include <windows.h>


 

#if defined(_WIN32)
#define _CDECL __cdecl
#else
#define _CDECL
#endif

using namespace std;


int _CDECL main(int argc, char **argv)
{
   printf("Checking prerequistes...Please wait\n");
   int j;
   long lSize = 0;
   char *cmd = "rexx -v 1>_temp.out";
   FILE* pFile;
   char *tempname = ".\\_temp.out";  

    // See if oorexx is installed
    j=system (cmd);  
    // See   if the _temp.out  exists    
    pFile = fopen(tempname,"rb");
    if (pFile == NULL) 
    {
        printf("Error:Unable to update current directory. \n");
        printf("  Reinstall Sat2Chart in Another directory eg:\n   C:\\Sat2Chart\\Sat2Chart.V1.x.x.x.x\\\n");
        // Sleep(10000); // sleep  10 seconds
       int msgboxID = MessageBox(
           NULL,
           "Error:Unable to update current directory.\n  Install Sat2Chart in another directory eg:\n  C:\\Sat2Chart\\Sat2Chart.V1.x.x.x.x\\\nDo you want to open the Sat2Chart Help?",
           "Sat2Chart Prerequisites",
           MB_ICONEXCLAMATION | MB_YESNO | MB_DEFBUTTON1
            );
        if (msgboxID == IDYES) // if yes
          j=system ("start .\\Help\\English\\index.html");
        exit(1);        
    }    
    else  // get the file size
    {     
      fseek (pFile , 0 , SEEK_END);
      lSize = ftell (pFile);
      rewind (pFile);    
      fclose(pFile);   
       // if the size is zero       
       if(lSize == 0)  
       {
           printf("Error: oorexx is not installed.\n");
           printf("  Download and install:\n   http://www.gdayii.ca/Downloads/ooRexx.5.0.0.11579-x86_32.exe \n");
          int msgboxID = MessageBox(
              NULL,
              "Error: Open Object Rexx is not installed or installed incorrectly.\nDo you want to install oorexx?\nIf Installing:\n  - take all defaults\n  - rerun Sat2Chart after.",
              "Sat2Chart Prerequisites Missing",
              MB_ICONEXCLAMATION | MB_YESNO | MB_DEFBUTTON1
               );
           if (msgboxID == IDNO) 
           {
             msgboxID = MessageBox(
                 NULL,
                 "Open Object Rexx program may be installed incorrectly\nDo you want to open the Sat2Chart Help and read the Problems section?",
                 "Sat2Chart Prerequisites Missing",
                 MB_ICONEXCLAMATION | MB_YESNO | MB_DEFBUTTON1
                  ); 
             if (msgboxID == IDYES) // if yes
               j=system ("start .\\Help\\English\\index.html");          
             exit(8); 
           }
           
           j=system ("Start http://www.gdayii.ca/Downloads/ooRexx.5.0.0.11579-x86_32.exe");
           exit(0);
             
           msgboxID = MessageBox(
                 NULL,
                 "When oorexx has been installed press Retry\nElse press Cancel to terminate installation.",
                 "Retry Installation",
                 MB_ICONINFORMATION | MB_RETRYCANCEL | MB_DEFBUTTON1
                 ); 
           if (msgboxID == IDCANCEL)  exit(8); // if cancel exit   
           j=system ("Start Sat2Chart.exe"); 
           exit(0);
       }
    }           
    
    // See   if Sat2Chart.options.txt exists
    char *filename = ".\\Sat2Chart.Options.txt";  
    // FILE* ftestexist;
    int exists = 1;
    pFile = fopen(filename,"rb");
    if (pFile==NULL)
        exists = 0;
    else
        fclose(pFile);
        
     int i = 0;    
    // if the file doesn't exist execute the CHECK.REX    
    if(exists == 0)
    {   
      i=system (".\\Check.REX");
      printf("Check.rex RC=%d\n",i);
    } 
     
    if (i == 0)
        i=system ("start rexxhide .\\Sat2Chart.REX");

     return 0;



    return 0;
}


